#include "cart.h"


// add notification number
void Cart::add(const Tenant& number)
{
	archive.push_back(number);
}

// clear all notifications
void Cart::clear()
{
	archive.clear();
}

// get notifications
const std::vector<Tenant>& Cart::get() const
{
	return archive;
}

// random notifications
void Cart::random(const unsigned int& size, std::vector<Tenant> tenants)
{
	std::shuffle(tenants.begin(), tenants.end(), std::default_random_engine(std::random_device{}()));
	while (archive.size() < size && tenants.size() > 0)
		archive.push_back(tenants.back()),
		tenants.pop_back();
}