#include "export.h"

// export html
void eHTML(const std::string& name, const std::vector<Tenant>& tenants)
{
	std::ofstream fout(name, std::ios::trunc);
	
	if (!fout.is_open())
	{
		std::string s = "error";
		throw std::runtime_error(s);
	}
	
	fout << "<html><body>\n";
	fout << "<table border=\"1\" style=\"width:100%\">\n";
	
	for (const auto& tenant : tenants)
	{
		fout << "<tr>\n";
		fout << "<td>" << tenant.getNumber() << "</td>\n";
		fout << "<td>" << tenant.getSurface() << "</td>\n";
		fout << "<td>" << tenant.getType() << "</td>\n";
		fout << "<td>" << tenant.getName() << "</td>\n";
		fout << "</tr>\n";
	}
	
	fout << "</table>\n";
	fout << "</body></html>\n";
	
	fout.close();
}

// export csv
void eCSV(const std::string& name, const std::vector<Tenant>& tenants)
{
	std::ofstream fout(name, std::ios::trunc);

	if (!fout.is_open())
	{
		std::string s = "error";
		throw std::runtime_error(s);
	}
	
	for (const auto& tenant : tenants)
	{
		fout << tenant.getNumber() << ';';
		fout << tenant.getSurface() << ';';
		fout << tenant.getType() << ';';
		fout << tenant.getName() << "\n";
	}
	
	fout.close();
}