#ifndef GUI_H
#define GUI_H

#include <QWidget>
#include <QtWidgets>
#include "service.h"
#include "domain.h"

class GUI : public QWidget
{
public:
    GUI(ServiceTenants&);
private:
    void addTenant();
    void initGUI();
    void connectSignals();
    void newArray(const std::vector<Tenant>& tenants);
    void newArray(const Tenant& tenant);
    ServiceTenants service;
    QHBoxLayout *lyMain;
    QVBoxLayout *newActionsLayout;
    QTableWidget *array;
    QListWidget *secondArray;
    QLineEdit *number, *surface, *owner, *type;
    QPushButton *actionAdd, *actionRemove, *actionModify, *actionWrite,
        *actionSearch, *actionFilterType, *actionFilterSurface,
        *actionSortName, *actionSortSurface, *actionSortTypeSurface,
        *actionNotifications, *actionMapReport, *actionUndo;
    QWidget *newActions;
};


class secondGUI : public QWidget
{
public:
    secondGUI(ServiceTenants&);
private:
    void addTenant();
    void initGUI();
    void connectSignals();
    void newArray(const std::vector<Tenant>& tenants);
    void newArray(const Tenant& tenant);
    ServiceTenants service;
    QHBoxLayout *lyMain;
    QTableWidget *array;
    QLineEdit *number, *owner;
    QPushButton *actionAddNotification, *actionClearNotifications,
        *actionRandomNotification, *actionWriteNotifications,
        *actionExportHTML, *actionExportCSV;
};

#endif
