#include "ui.h"

// console constructor
Console::Console(ServiceTenants service)
: service(service)
{
}

// main function to run ui
void Console::run()
{
	int action = 1;
	while (action)
	{
		writePossibleActions();
		std::cin >> action;
		doAction(action);
		notificationsWrite();
	}
}

// add tenant
void Console::add()
{
	int apNumber = 0, surface = 0;
	std::string name = "", type = "";
	
	std::cout << "write ap number\n";
	std::cin >> apNumber;
	
	std::cout << "write ap surface\n";
	std::cin >> surface;
	
	std::cout << "write ap type\n";
	std::cin >> type;
	
	std::cout << "write owner name\n";
	std::cin >> name;
	
	service.add(apNumber, surface, type, name);
}

// remove tenant
void Console::remove()
{
	int apNumber = 0;
	
	std::cout << "write ap number\n";
	std::cin >> apNumber;
	
	service.remove(apNumber);
}

// modify tenant
void Console::modify()
{
	int apNumber = 0, surface = 0;
	std::string name = "", type = "";
	
	std::cout << "write ap number\n";
	std::cin >> apNumber;
	
	std::cout << "write ap surface\n";
	std::cin >> surface;
	
	std::cout << "write ap type\n";
	std::cin >> type;
	
	std::cout << "write owner name\n";
	std::cin >> name;
	
	service.modify(apNumber, surface, type, name);
}

// write tenant
void Console::writeTenant(const Tenant& obj)
{
	std::cout << obj.getNumber() << ' ';
	std::cout << obj.getSurface() << ' ';
	std::cout << obj.getType() << ' ';
	std::cout << obj.getName() << '\n';
}

// write tenants
void Console::writeTenants(const std::vector<Tenant>& tenants)
{
	for (const auto& tenant : tenants)
		writeTenant(tenant);
}

// write
void Console::write()
{
	writeTenants(service.getTenants());
}

// search tenant
void Console::search()
{
	int apNumber = 0;
	
	std::cout << "write ap number\n";
	std::cin >> apNumber;
	
	writeTenant(service.search(apNumber));
}

// filter tenants using type
void Console::filterType()
{
	std::string type = "";
	
	std::cout << "write ap type\n";
	std::cin >> type;
	
	writeTenants(service.filterType(type));
}

// filter using surface
void Console::filterSurface()
{
	int surface = 0;	
	
	std::cout << "write ap surface\n";
	std::cin >> surface;
	
	writeTenants(service.filterSurface(surface));
}

// sort name
void Console::sortName()
{
	writeTenants(service.sortName());
}

// sort using surface
void Console::sortSurface()
{
	writeTenants(service.sortSurface());
}

// sort using type and surface
void Console::sortTypeSurface()
{
	writeTenants(service.sortTypeSurface());
}	

// add notifications
void Console::notificationsAdd()
{
	int n = 0;
	
	std::cout << "write notification number\n";
	std::cin >> n;
	
	service.addCart(n);
}

// clear notifications
void Console::notificationsClear()
{
	service.clearCart();
}

// notifications random
void Console::notificationsRandom()
{
	int n = 0;
	
	std::cout << "write apratments number\n";
	std::cin >> n;
	
	service.randomCart(n);
}

// write notifications
void Console::notificationsWrite()
{
	for (const auto& tenant : service.getCart())
		writeTenant(tenant);
}

// ui for map action
void Console::mapAction()
{
	for (const auto& [number, surface] : service.mapReport())
		std::cout << number << ' ' << surface << '\n';
}

// undo
void Console::undo()
{
	service.undo();
}

// export html
void Console::exportHTML()
{
	std::string name;
	
	std::cout << "write name\n";
	std::cin >> name;
	
	service.exportHTML(name);
}

// export csv
void Console::exportCSV()
{
	std::string name;
	
	std::cout << "write name\n";
	std::cin >> name;
	
	service.exportCSV(name);
}

// select action
void Console::doAction(int action)
{
	try
	{
		if (action == 0)
			return;
		if (action == 1)
		{
			add();
			return;
		}
		if (action == 2)
		{
			remove();
			return;
		}
		if (action == 3)
		{
			modify();
			return;
		}
		if (action == 4)
		{
			write();
			return;
		}
		if (action == 5)
		{
			search();
			return;
		}
		if (action == 6)
		{
			filterType();
			return;
		}
		if (action == 7)
		{
			filterSurface();
			return;
		}
		if (action == 8)
		{
			sortName();
			return;
		}
		if (action == 9)
		{
			sortSurface();
			return;
		}
		if (action == 10)
		{
			sortTypeSurface();
			return;
		}
		if (action == 11)
		{
			notificationsAdd();
			return;
		}
		if (action == 12)
		{
			notificationsClear();
			return;
		}
		if (action == 13)
		{
			notificationsRandom();
			return;
		}
		if (action == 14)
		{
			notificationsWrite();
			return;
		}
		if (action == 15)
		{
			mapAction();
			return;
		}
		if (action == 16)
		{
			undo();
			return;
		}
		if (action == 17)
		{
			exportHTML();
			return;
		}
		if (action == 18)
		{
			exportCSV();
			return;
		}
	}
	catch (const ValidException& ex)
	{
		std::cout << ex << '\n';
	}
	catch (const RepositoryException& ex)
	{
		std::cout << ex << '\n';
	}
}

// write actions
void Console::writePossibleActions()
{
	std::cout << "17 = export HTML\n";
	std::cout << "18 = export CSV\n";
}