#include "undo.h"

// undo action destructor
UndoAction::~UndoAction()
{
}

// undo add constructor
UndoAdd::UndoAdd(RepositoryAbstract& repository, const Tenant& tenant)
: repository(repository)
, tenant(tenant)
{
}

// undo add
void UndoAdd::undo()
{
	repository.remove(tenant.getNumber());
}

// undo add destructor
UndoAdd::~UndoAdd()
{	
}

// undo remove constructor
UndoRemove::UndoRemove(RepositoryAbstract& repository, const Tenant& tenant)
: repository(repository)
, tenant(tenant)
{	
}

// undo remove
void UndoRemove::undo()
{
	repository.add(tenant);
}

// undo remove destructor
UndoRemove::~UndoRemove()
{	
}

// undo modify constructor
UndoModify::UndoModify(RepositoryAbstract& repository, const Tenant& tenant)
: repository(repository)
, tenant(tenant)
{	
}

// undo modify
void UndoModify::undo()
{
	repository.remove(tenant.getNumber());
	repository.add(tenant);
}

// undo modify destructor
UndoModify::~UndoModify()
{
}