#ifndef UNDO_H
#define UNDO_H

#include "repository.h"

class UndoAction
{
	
public:

	virtual void undo() = 0;
	virtual ~UndoAction();
	
};

class UndoAdd : public UndoAction
{
	
public:

	UndoAdd(RepositoryAbstract&, const Tenant&);
	void undo() override;
	~UndoAdd();
	
private:

	RepositoryAbstract &repository;
	Tenant tenant;

};

class UndoRemove : public UndoAction
{	

public:

	UndoRemove(RepositoryAbstract&, const Tenant&);
	void undo() override;
	~UndoRemove();
	
private:

	RepositoryAbstract &repository;
	Tenant tenant;

};

class UndoModify : public UndoAction
{
	
public:

	UndoModify(RepositoryAbstract&, const Tenant&);
	void undo() override;
	~UndoModify();
	
private:

	RepositoryAbstract &repository;
	Tenant tenant;
	
};

#endif