#include "valid.h"

// valid exception constructor
ValidException::ValidException(const std::vector<std::string>& s)
: s(s)
{
}

// operator overloading <<
std::ostream& operator<<(std::ostream& out, const ValidException& e)
{
	for (const auto& i : e.s)
		out << i << '\n';
	return out;
}

// valid tenant
void Valid::validate(const Tenant& tenant)
{	
	const int five = 5;
	std::vector<std::string> s;
	if (tenant.getNumber() <= 0)
		s.push_back("error tenant.getNumber() <= 0");
	if (tenant.getSurface() <= 0)
		s.push_back("error tenant.getSurface() <= 0");
	if (tenant.getType().size() < five)
		s.push_back("error tenant.getType() < 5");
	if (tenant.getName().size() < five)
		s.push_back("error tenant.getName() < 5");
	if (s.size())
		throw ValidException(s);
}